#!/usr/bin/env python

import sys
import stats

depth = 2

if sys.argv[3] != '':
    depth = int(sys.argv[3])

if depth == 1:
    from depth1names import *
if depth == 2:
    from depth2names import *


def pretty_print(name, l, key):
    s = stats.ldescribe(l)
    l.sort()
    median = l[len(l) / 2]
    print '\\hspace{0.3cm} in %s & %d & %.1f & %.1f & %d & %d & %d \\\ ' % (name,int(sum(data[key][2])),s[2],s[3],s[1][1],s[1][0],len(data[key][1]))
    
 
"""
    print "**** unit %s used *****" % name
    print "kurt. %.2f %s"     % (s[5],name)
    print "min. %d %s"        % (s[1][0],name)
    print "max. %d %s"        % (s[1][1],name)
    print "mean. %.2f %s"     % (s[2],name)
    print "std. dev. %.2f %s" % (s[3],name)
    print "skew. %.2f %s"     % (s[4],name)
    print "kurt. %.2f %s"     % (s[5],name)
    print "***"
"""




# placement in log file
#(XEN) mb_p,2,0,0,0,1690
#(XEN) mb_p,2,1,378,289,1690
#(XEN) mb_p,2,2,798,517,1690
#(XEN) mb_p,0,4,3402,1916,126,192
#    0,     1,2,3,   4,   5,  6
#
#(XEN) mb_c,4,123,
#    0,     1, 2
#
# 
# 18446744073709530287

printnr = 1
timernr = 2
cycle = 3
time = 4
count = 5
#mb_data->wait = 6

lessthen3 = 0
invalidcount = 0
otherprints = 0

useonly = sys.argv[2]

data =  {}

for i in range(1,2):
    filename = (sys.argv[1]).replace('run1',"run" + str(i))
    print r'% file:' + filename
    f = open(filename, "r")

    for l in f.readlines():
	if l[0:10] == "(XEN) mb_c":
            res = l.split(',')
            if((res[2] != '0') and (data.has_key(int(res[1])))):
                (data[int(res[1])][2]).append(int(res[2]))
        if l[0:10] == "(XEN) mb_p":
            res = l.split(',')
            if (res[printnr] != useonly) or (res[cycle] == '0' or int(res[cycle]) > 10000000000000000):
                if (int(res[cycle]) > 10000000000000000):
                    invalidcount += 1
#                        print l
                otherprints += 1
                continue
                        
            timer_nr = int(res[timernr])
            if not data.has_key(timer_nr):
                data[timer_nr] = ([],[],[])
            data[timer_nr][0].append(int(res[cycle]))
            data[timer_nr][1].append(int(res[time]))
            data[timer_nr][2].append(int(res[count]))
                        


print r'\begin{table}'
print r'\centering'
print r'  \begin{tabular}{l|c|c|c|c|c|c}'
print r'   \textbf{Function} & \rotatebox{90}{\textbf{Count}} & \rotatebox{90}{\textbf{Mean}} & \rotatebox{90}{\textbf{Std. dev.}} &\rotatebox{90}{\textbf{Max.}} & \rotatebox{90}{\textbf{Min.}} & \rotatebox{90}{\textbf{Sample size}} \\' 
#print r'    \hline'
print r' '


for key in data.keys():
    if(len(data[key][0]) < 3):
        lessthen3 += 1
        continue
    print r'\hline'
    print "%s & & & & & & \\\ " % (c[key]).replace('_','\_')
    pretty_print("cycles", data[key][0],key)
    pretty_print("nano sec.", data[key][1],key)


print  r'\end{tabular} '
print  r'\caption{'+ (sys.argv[1]).replace('_','\_') + r'.}'
print  r'\label{tab:' + (sys.argv[1]).replace('.log', '') + r'}'
print  r'\end{table}'

print r'%' + " file: %s " %  sys.argv[1]
print r'% depth set ' + str(depth)
print r'%' + " invalidcount %d " %  invalidcount
print r'%' + " otherprints %d " %  otherprints
print r'%' + " lessthen3 %d " %  lessthen3

